place 0h

N	EQU	5746		; nmero a converter para caracteres
base	EQU	1000H		; endereo em memria onde colocar o 1 carcter
maxdiv	EQU	10000		; mximo divisor potncia de 10 para nmeros em 16 bits
mscara	EQU	30H		; mscara para converter dgito em carcter

incio:	MOV	R1, N		; nmero a converter para caracteres
	MOV	R2, base	; inicializa apontador para o primeiro carcter
	MOV	R3, maxdiv	; inicializa divisor potncia de 10
	MOV	R4, mscara	; mscara para converter dgito em carcter
	MOV	R5, 0		; inicializa indicador de zero  esquerda
	MOV	R6, 10
maisUm:	MOV	R0, R1		; cpia de R1 (porque o DIV destri o valor do
				; registo)
	DIV	R0, R3		; obtm dgito de maior peso (em base 10)
	OR	R5, R0		; s d zero se o dgito for 0 e ainda no tiver
				; havido dgitos diferentes de zero
	JZ	prximo		; zeros  esquerda no interessam
	OR	R0, R4		; converte dgito para carcter ASCII
	MOVB	[R2], R0	; armazena carcter na memria
	ADD	R2, 1		; actualiza endereo (em bytes) do prximo carcter
prximo:MOD	R1, R3		; retira dgito de maior peso ao nmero a converter
	DIV	R3, R6		; divide divisor por 10 para tratar do dgito seguinte
	JNZ	maisUm		; ainda h mais caracteres para tratar
ltimo:	OR	R1, R4		; converte ltimo dgito (menor peso) para carcter
				; ASCII
	MOVB	[R2], R1	; armazena ltimo carcter
	MOV	R3, 0		; esta instruo  dispensvel pois nesta altura R3 j
				;  0, mas sem ela fica mais obscuro e  uma potencial
				; fonte de erros em caso de alterao do programa!
	MOVB	[R2],	R3	; escreve 0 (terminador) no fim da cadeia de 
				; caracteres
fim:	JMP	fim		; acabou. 




